## mingw-w64-jom-1.1.5-1.src.tar.zst

=== src/app/CMakeLists.txt ===
file(READ version.txt version)
string(REGEX REPLACE "[\r\n]" "" version ${version})
string(REPLACE "." ";" version_list ${version})
list(GET version_list 0 JOM_VERSION_MAJOR)
list(GET version_list 1 JOM_VERSION_MINOR)
list(GET version_list 2 JOM_VERSION_PATCH)

configure_file(
    app.rc.in
    app.rc)

add_executable(jom
  application.cpp
  application.h
  main.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/app.rc
  )

target_compile_definitions(jom
    PRIVATE JOM_VERSION_MAJOR=${JOM_VERSION_MAJOR}
    PRIVATE JOM_VERSION_MINOR=${JOM_VERSION_MINOR}
    PRIVATE JOM_VERSION_PATCH=${JOM_VERSION_PATCH}
    )

set_target_properties(jom PROPERTIES DEBUG_POSTFIX d)
target_link_libraries(jom PRIVATE jomlib)

install(TARGETS jom RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

=== src/jomlib/CMakeLists.txt ===
add_library(jomlib STATIC
  commandexecutor.cpp
  commandexecutor.h
  dependencygraph.cpp
  dependencygraph.h
  exception.cpp
  exception.h
  fastfileinfo.cpp
  fastfileinfo.h
  filetime.cpp
  filetime.h
  helperfunctions.cpp
  helperfunctions.h
  iocompletionport.cpp
  iocompletionport.h
  jobclient.cpp
  jobclient.h
  jobclientacquirehelper.cpp
  jobclientacquirehelper.h
  jobserver.cpp
  jomprocess.cpp
  jomprocess.h
  macrotable.cpp
  macrotable.h
  makefile.cpp
  makefile.h
  makefilefactory.cpp
  makefilefactory.h
  makefilelinereader.cpp
  makefilelinereader.h
  options.cpp
  options.h
  parser.cpp
  parser.h
  ppexpr_grammar.cpp
  ppexpr_grammar_p.h
  ppexprparser.cpp
  ppexprparser.h
  preprocessor.cpp
  preprocessor.h
  stable.h
  targetexecutor.cpp
  targetexecutor.h
  )

target_include_directories(jomlib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(jomlib PUBLIC Qt5::Core)

# If we're building against a static Qt on Windows,
# we must link manually against all private libraries.
# This should not be necessary. See QTBUG-38913.
get_target_property(qt_core_type Qt5::Core TYPE)
if(qt_core_type MATCHES STATIC_LIBRARY)
    target_link_libraries(jomlib PRIVATE mincore userenv winmm ws2_32)

    if(CMAKE_BUILD_TYPE MATCHES Debug)
        set(debug_suffix d)
        set(qt_build_config DEBUG)
    else()
        set(debug_suffix "")
        set(qt_build_config RELEASE)
    endif()

    get_target_property(qt_core_lib_location Qt5::Core IMPORTED_LOCATION_${qt_build_config})
    get_filename_component(qt_core_lib_dir ${qt_core_lib_location} DIRECTORY)
    target_link_libraries(jomlib PRIVATE "${qt_core_lib_dir}/qtpcre2${debug_suffix}.lib")
endif()

target_compile_definitions(jomlib PRIVATE
  QT_NO_CAST_FROM_ASCII
  QT_NO_CAST_TO_ASCII
  UNICODE
  )

if(MSVC)
  target_compile_definitions(jomlib PUBLIC
    _CRT_SECURE_NO_WARNINGS
    )
endif()

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=jom
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgdesc="JOM - the parallel make tool for Windows (mingw-w64)"
pkgver=1.1.5
pkgrel=1
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://wiki.qt.io/Jom'
msys2_repository_url="https://github.com/qt-labs/jom"
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-qt5-base")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/qt-labs/jom/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('ff72c0d484dac9792037354479984aa97c011011de556cc548d2423946ce1947')

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DBUILD_TESTING=OFF \
    "${_extra_config[@]}" \
    -S ${_realname}-${pkgver} \
    -B build-${MSYSTEM}

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.GPL \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
